/*
 * Copyright 2010, Ingo Weinhold, ingo_weinhold@gmx.de.
 * Distributed under the terms of the MIT License.
 */
#ifndef DEBUG_H
#define DEBUG_H


#include <stdarg.h>

#include <SupportDefs.h>


#ifdef __cplusplus
extern "C" {
#endif

void debug_init_post_mmu(void);
void debug_cleanup(void);
void kprintf(const char *format, ...);

#ifdef __cplusplus
}
#endif

/* STATIC_ASSERT is a compile-time check that can be used to             */
/* verify static expressions such as: STATIC_ASSERT(sizeof(int64) == 8); */
#define STATIC_ASSERT(x)								\
	do {												\
		struct __staticAssertStruct__ {					\
			char __static_assert_failed__[2*(x) - 1];	\
		};												\
	} while (false)

#endif	// DEBUG_H
